update.sh: do nothing if .nofetch exists
[girocco.git] / jobd / update.sh
blobc9ba641863c02f545bda9e5208588bda0890280c
1 #!/bin/sh
3 . @basedir@/shlib.sh
5 set -e
7 if [ $# -ne 1 ]; then
8 echo "Usage: update.sh projname" >&2
9 exit 1
12 # date -R is linux-only, POSIX equivalent is '+%a, %d %b %Y %T %z'
13 datefmt='+%a, %d %b %Y %T %z'
15 # freshen_loose_objects full-sha ...
16 # if "$n" is a loose object, set its modification time to now
17 # otherwise silently do nothing with no error. To facilitate conversion
18 # of mirror projects to push projects we also add group write permission.
19 freshen_loose_objects() {
20 _list=
21 for _sha; do
22 _fn="${_sha#??}"
23 _shard="${_sha%$_fn}"
24 _list="$_list objects/$_shard/$_fn"
25 done
26 if [ -n "$_list" ]; then
27 chmod ug+w $_list 2>/dev/null || :
28 touch -c $_list 2>/dev/null || :
32 # darcs fast-export | git fast-import with error handling
33 git_darcs_fetch() (
34 set_utf8_locale
35 _err1=
36 _err2=
37 exec 3>&1
38 { read -r _err1 || :; read -r _err2 || :; } <<-EOT
40 exec 4>&3 3>&1 1>&4 4>&-
42 _e1=0
43 "$cfg_basedir"/bin/darcs-fast-export \
44 --export-marks="$(pwd)/dfe-marks" \
45 --import-marks="$(pwd)/dfe-marks" "$1" 3>&- || _e1=$?
46 echo $_e1 >&3
47 } | \
49 _e2=0
50 git fast-import \
51 --export-marks="$(pwd)/gfi-marks" \
52 --export-pack-edges="$(pwd)/gfi-packs" \
53 --import-marks="$(pwd)/gfi-marks" \
54 --force 3>&- || _e2=$?
55 echo $_e2 >&3
58 EOT
59 exec 3>&-
60 [ "$_err1" = 0 -a "$_err2" = 0 ]
61 return $?
64 # bzr fast-export | git fast-import with error handling
65 git_bzr_fetch() (
66 set_utf8_locale
67 BZR_LOG=/dev/null
68 export BZR_LOG
69 _err1=
70 _err2=
71 exec 3>&1
72 { read -r _err1 || :; read -r _err2 || :; } <<-EOT
74 exec 4>&3 3>&1 1>&4 4>&-
76 _e1=0
77 bzr fast-export --plain \
78 --export-marks="$(pwd)/dfe-marks" \
79 --import-marks="$(pwd)/dfe-marks" "$1" 3>&- || _e1=$?
80 echo $_e1 >&3
81 } | \
83 _e2=0
84 git fast-import \
85 --export-marks="$(pwd)/gfi-marks" \
86 --export-pack-edges="$(pwd)/gfi-packs" \
87 --import-marks="$(pwd)/gfi-marks" \
88 --force 3>&- || _e2=$?
89 echo $_e2 >&3
92 EOT
93 exec 3>&-
94 [ "$_err1" = 0 -a "$_err2" = 0 ]
95 return $?
98 [ -n "$cfg_mirror" ] || { echo "Mirroring is disabled" >&2; exit 0; }
100 umask 002
101 [ "$cfg_permission_control" != "Hooks" ] || umask 000
102 clean_git_env
104 proj="${1%.git}"
105 cd "$cfg_reporoot/$proj.git"
107 trap 'if [ $? != 0 ]; then echo "update failed dir: $PWD" >&2; fi; rm -f "$bang_log"' EXIT
108 trap 'exit 130' INT
109 trap 'exit 143' TERM
111 if check_interval lastrefresh $cfg_min_mirror_interval; then
112 progress "= [$proj] update skip (last at $(config_get lastrefresh))"
113 exit 0
115 if [ -e .nofetch ]; then
116 progress "x [$proj] update disabled (.nofetch exists)"
117 exit 0
119 progress "+ [$proj] update (`date`)"
121 # Any pre-existing FETCH_HEAD from a previous fetch failed or not is garbage
122 rm -f FETCH_HEAD
124 # A previous failed update attempt can leave a huge tmp_pack_XXXXXX file behind.
125 # Since no pushes are allowed to mirrors, we know that any such files that exist
126 # at this point in time are garbage and can be safely deleted, we do not even
127 # need to check how old they are. A tmp_idx_XXXXXX file is also created during
128 # the later stages of the fetch process, so we kill any of those as well.
129 find objects/pack -maxdepth 1 -type f -name "tmp_pack_?*" -print0 | xargs -0 rm -f
130 find objects/pack -maxdepth 1 -type f -name "tmp_idx_?*" -print0 | xargs -0 rm -f
132 # Make sure we have a reflogs subdirectory and abort the update if not
133 # This should not count as a normal "bang" failure if unsuccessful
134 [ -d reflogs ] || mkdir -p reflogs >/dev/null 2>&1 || :
135 [ -d reflogs ]
137 bang_setup
138 bang_action="update"
139 bang_trap() {
140 if [ -n "$1" ]; then
141 # Throttle retries
142 # Since gitweb shows the .last_refresh date, it's safe to update
143 # gitweb.lastrefresh to throttle the updates w/o corrupting the
144 # last refresh date display on the gitweb summary page
145 # It's therefore important that we do NOT touch .last_refresh here
146 config_set lastrefresh "$(date "$datefmt")"
150 bang echo "Project: $proj"
151 bang echo ""
152 mail="$(config_get owner || :)"
153 url="$(config_get baseurl || :)"
154 case "$url" in *" "*|*" "*|"")
155 bang_eval 'echo "Bad mirror URL (\"$url\")"; ! :'
156 exit 1
157 esac
158 bang echo "Mirroring from URL \"$url\""
159 bang echo ""
160 statusok="$(git config --bool gitweb.statusupdates 2>/dev/null || echo true)"
161 mailaddrs=''
162 [ "$statusok" = "false" -o -z "$mail" ] || mailaddrs="$mail"
163 [ -z "$cfg_admincc" -o "$cfg_admincc" = "0" -o -z "$cfg_admin" ] || \
164 if [ -z "$mailaddrs" ]; then mailaddrs="$cfg_admin"; else mailaddrs="$mailaddrs,$cfg_admin"; fi
166 bang_eval "git for-each-ref --format '%(refname) %(objectname)' >.refs-temp"
167 bang_eval "LC_ALL=C sort -b -k1,1 <.refs-temp >.refs-before"
168 ! [ -e .delaygc ] || >.allowgc || :
169 svnpackcreated=
171 case "$url" in
172 svn://* | svn+http://* | svn+https://* | svn+file://* | svn+ssh://*)
173 [ -n "$cfg_mirror_svn" ] || { echo "Mirroring svn is disabled" >&2; exit 0; }
174 # Use an 'anonsvn' username as is commonly used for anonymous svn
175 # Use an 'anonsvn' password as is commonly used for anonymous svn
176 GIT_ASKPASS_PASSWORD=anonsvn
177 export GIT_ASKPASS_PASSWORD
178 # Update the git svn url to match baseurl but be cognizant of any
179 # needed prefix changes. See the comments in taskd/clone.sh about
180 # why we need to put up with a prefix in the first place.
181 case "$url" in svn+ssh://*) svnurl="$url";; *) svnurl="${url#svn+}";; esac
182 svnurl="${svnurl%/}"
183 svnurlold="$(config_get svnurl || :)"
184 if [ "$svnurl" != "$svnurlold" ]; then
185 # We better already have an svn-remote.svn.fetch setting
186 bang test -n "$(git config --get-all svn-remote.svn.fetch || :)"
187 # the only way to truly know what the proper prefix is
188 # is to attempt a fresh git-svn init -s on the new url
189 rm -rf svn-new-url || :
190 # We require svn info to succeed on the URL otherwise it's
191 # simply not a valid URL and without using -s on the init it
192 # will not otherwise be tested until the fetch
193 bang eval 'svn --non-interactive --username anonsvn --password anonsvn info "$svnurl" > /dev/null'
194 bang mkdir svn-new-url
195 GIT_DIR=svn-new-url bang git init --bare --quiet
196 # We initially use -s for the init which will possibly shorten
197 # the URL. However, the shortening can fail if a password is
198 # not required for the longer version but is for the shorter,
199 # so try again without -s if the -s version fails.
200 cmdstr='git svn init --username=anonsvn --prefix "" -s "$svnurl" < /dev/null > /dev/null 2>&1 || '
201 cmdstr="$cmdstr"'git svn init --username=anonsvn --prefix "" "$svnurl" < /dev/null > /dev/null 2>&1'
202 GIT_DIR=svn-new-url bang eval "$cmdstr"
203 gitsvnurl="$(GIT_DIR=svn-new-url git config --get svn-remote.svn.url || :)"
204 gitsvnfetch="$(GIT_DIR=svn-new-url git config --get svn-remote.svn.fetch || :)"
205 gitsvnprefixnew="${gitsvnfetch%%:*}"
206 gitsvnsuffixnew="${gitsvnprefixnew##*/}"
207 gitsvnprefixnew="${gitsvnprefixnew%$gitsvnsuffixnew}"
208 rm -rf svn-new-url || :
209 # Using GIT_DIR= with bang leaves it set to svn-new-url, so reset it to .
210 GIT_DIR=.
211 if [ "$gitsvnurl" != "$(git config --get svn-remote.svn.url || :)" ]; then
212 # The url has been changed.
213 # We must update the url and replace the prefix on all config items
214 gitsvnfetch="$(git config --get-all svn-remote.svn.fetch | head -1 || :)"
215 gitsvnprefixold="${gitsvnfetch%%:*}"
216 gitsvnsuffixold="${gitsvnprefixold##*/}"
217 gitsvnprefixold="${gitsvnprefixold%$gitsvnsuffixold}"
218 git config --remove-section 'svn-remote.svnnew' 2>/dev/null || :
219 git config 'svn-remote.svnnew.url' "$gitsvnurl"
220 { git config --get-regexp '^svn-remote\.svn\.' || :; } | \
221 { while read sname sval; do
222 case "$sname" in
223 svn-remote.svn.fetch|svn-remote.svn.branches|svn-remote.svn.tags)
224 sname="${sname#svn-remote.svn.}"
225 sval="${sval#$gitsvnprefixold}"
226 bang git config --add "svn-remote.svnnew.$sname" "${gitsvnprefixnew}$sval"
227 esac
228 done; }
229 bang git config -f svn/.metadata svn-remote.svn.reposRoot "$gitsvnurl"
230 bang git config --remove-section svn-remote.svn
231 bang git config --rename-section svn-remote.svnnew svn-remote.svn
233 bang config_set svnurl "$svnurl"
235 # remove any stale *.lock files greater than 1 hour old in case
236 # git-svn was killed on the last update because it took too long
237 find svn -type f -name '*.lock' -mmin +60 -print0 2>/dev/null | xargs -0 rm -f
238 # remember the starting time so we can easily combine fetched loose objects
239 # we sleep for 1 second after creating .svnpack to make sure all objects are newer
240 if ! [ -e .svnpack ]; then
241 svnpackcreated=1
242 rm -f .svnpack
243 >.svnpack
244 sleep 1
246 GIT_DIR=. bang git svn fetch --log-window-size=$var_log_window_size --username=anonsvn --quiet < /dev/null
247 # git svn does not preserve group permissions in the svn subdirectory
248 chmod -R ug+rw,o+r svn
249 # git svn also leaves behind ref turds that end with @nnn
250 # We get rid of them now
251 git for-each-ref --format='%(objectname) %(refname)' | \
252 { while read sha1 ref; do
253 case "$ref" in
254 ?*@[1-9]|?*@[1-9][0-9]|?*@[1-9][0-9][0-9]|?*@[1-9][0-9][0-9][0-9]|\
255 ?*@[1-9][0-9][0-9][0-9][0-9]|?*@[1-9][0-9][0-9][0-9][0-9][0-9]|\
256 ?*@[1-9][0-9][0-9][0-9][0-9][0-9][0-9]|\
257 ?*@[1-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9])
258 git update-ref -d "$ref"
259 esac
260 done; }
261 unset GIT_ASKPASS_PASSWORD
263 darcs://*)
264 [ -n "$cfg_mirror_darcs" ] || { echo "Mirroring darcs is disabled" >&2; exit 0; }
265 httpurl="http://${url#darcs://}"
266 # remove any stale lock files greater than 1 hour old in case
267 # darcs_fast_export was killed on the last update because it took too long
268 find *.darcs -maxdepth 2 -type f -name 'lock' -mmin +60 -print0 2>/dev/null | xargs -0 rm -f
269 bang git_darcs_fetch "$httpurl"
271 bzr://*)
272 [ -n "$cfg_mirror_bzr" ] || { echo "Mirroring bzr is disabled" >&2; exit 0; }
273 bzrurl="${url#bzr://}"
274 bang git_bzr_fetch "$bzrurl"
276 hg+http://* | hg+https://* | hg+file://* | hg+ssh://*)
277 [ -n "$cfg_mirror_hg" ] || { echo "Mirroring hg is disabled" >&2; exit 0; }
278 # We just remove hg+ here, so hg+http://... becomes http://...
279 hgurl="${url#hg+}"
280 # Fetch any new updates
281 bang hg -R "$(pwd)/repo.hg" pull
282 # Do the fast-export | fast-import
283 bang git_hg_fetch
286 [ "$url" = "$(git config --get remote.origin.url || :)" ] || bang config_set_raw remote.origin.url "$url"
287 pruneopt=--prune
288 [ "$(git config --bool fetch.prune 2>/dev/null || :)" != "false" ] || pruneopt=
289 git_add_config 'fetch.unpackLimit=1'
290 # Note the git config documentation is wrong
291 # transfer.unpackLimit, if set, overrides fetch.unpackLimit
292 git_add_config 'transfer.unpackLimit=1'
293 if ! is_gfi_mirror_url "$url"; then
294 lastwasclean=
295 [ "$(git config --bool girocco.lastupdateclean 2>/dev/null || :)" != "true" ] || lastwasclean=1
296 nextisclean=
297 [ "$(git config --bool girocco.cleanmirror 2>/dev/null || :)" != "true" ] || nextisclean=1
298 if [ "$nextisclean" != "$lastwasclean" ]; then
299 if [ -n "$nextisclean" ]; then
300 git config --replace-all remote.origin.fetch "+refs/heads/*:refs/heads/*"
301 git config --add remote.origin.fetch "+refs/tags/*:refs/tags/*"
302 git config --add remote.origin.fetch "+refs/notes/*:refs/notes/*"
303 else
304 git config --replace-all remote.origin.fetch "+refs/*:refs/*"
308 # remember the starting time so we can easily detect new packs for fast-import mirrors
309 # we sleep for 1 second after creating .gfipack to make sure all packs are newer
310 if is_gfi_mirror_url "$url" && [ ! -e .gfipack ]; then
311 rm -f .gfipack
312 >.gfipack
313 sleep 1
315 GIT_SSL_NO_VERIFY=1 bang git remote update $pruneopt
316 if ! is_gfi_mirror_url "$url" && [ "$nextisclean" != "$lastwasclean" ]; then
317 if [ -n "$nextisclean" ]; then
318 # We must manually purge the unclean refs now as even prune won't do it
319 git for-each-ref --format='%(refname)' |
320 while read -r aref; do
321 case "$aref" in refs/heads/*|refs/tags/*|refs/notes/*) :;; *)
322 git update-ref -d "$aref"
323 esac
324 done
326 git config --bool girocco.lastupdateclean ${nextisclean:-0}
328 if [ -e .gfipack ] && is_gfi_mirror_url "$url"; then
329 find objects/pack -type f -newer .gfipack -name "pack-$octet20.pack" -print >>gfi-packs
330 rm -f .gfipack
333 esac
335 # The objects subdirectories permissions must be updated now.
336 # In the case of a dumb http clone, the permissions will not be correct
337 # (missing group write) despite the core.sharedrepository=1 setting!
338 # The objects themselves seem to have the correct permissions.
339 # This problem appears to have been fixed in the most recent git versions.
340 perms=g+w
341 [ "$cfg_permission_control" != "Hooks" ] || perms=go+w
342 chmod $perms $(find objects -maxdepth 1 -type d) 2>/dev/null || :
344 bang git update-server-info
346 # We maintain the last refresh date in two places deliberately
347 # so that it's available as part of the config data and also
348 # as a standalone file timestamp that can be accessed without git.
349 bang config_set lastrefresh "$(date "$datefmt")"
350 { >.last_refresh; } 2>/dev/null || :
352 # Check to see if any refs changed
353 bang_eval "git for-each-ref --format '%(refname) %(objectname)' >.refs-temp"
354 bang_eval "LC_ALL=C sort -b -k1,1 <.refs-temp >.refs-after"
355 refschanged=
356 cmp -s .refs-before .refs-after || refschanged=1
358 # There's no way to get git svn to fetch packs, so we always need to run
359 # a mini-gc afterwards if svn actually fetched anything, but that's okay
360 # because it will be very quick
361 if [ -z "$refschanged" -a -n "$svnpackcreated" ]; then
362 # we created the .svnpack but didn't actually fetch anything
363 # so remove it to avoid forcing a mini-gc if not necessary
364 rm -f .svnpack
366 if [ -e .svnpack ] && ! [ -e .needsgc ]; then
367 >.needsgc
370 # Force a mini-gc if $Girocco::Config::delay_gfi_redelta is false and there's
371 # at least one gfi pack present now
372 if [ -z "$cfg_delay_gfi_redelta" ] && ! [ -e .needsgc ] && \
373 [ -f gfi-packs -a -s gfi-packs ] && is_gfi_mirror_url "$url"; then
374 >.needsgc
377 # Activate a mini-gc if there are at least 20 packs present now
378 if ! [ -e .needsgc ]; then
379 packs=
380 { packs="$(list_packs --quiet --count --exclude-no-idx objects/pack || :)" || :; } 2>/dev/null
381 if [ -n "$packs" ] && [ "$packs" -ge 20 ]; then
382 >.needsgc
386 # Look at which refs changed and trigger ref-change for these
387 sockpath="$cfg_chroot/etc/taskd.socket"
388 if [ -n "$refschanged" ]; then
389 bang config_set lastreceive "$(date '+%a, %d %b %Y %T %z')"
390 # We always use UTC for the log timestamp so that chroot and non-chroot match up.
391 # We don't have to worry about multiple log files since only one update runs
392 lognamets="$(TZ=UTC date '+%Y%m%d_%H%M%S')"
393 loghhmmss="${lognamets##*_}"
394 logname="reflogs/${lognamets%%_*}"
395 # We freshen the mod time to now on any old or new ref that is a loose object
396 # For old refs we do it so we will be able to keep them around for 1 day
397 # For new refs we do it in case we are about to run gc and the new ref
398 # actually points to an oldish loose object that had been unreachable
399 # We probably do not need to do it for new refs as Git tries to do that,
400 # but since we're already doing it for old refs (which Git does not do),
401 # it's almost no extra work for new refs, just in case.
403 echo "ref-changes %$proj% $proj"
404 LC_ALL=C join .refs-before .refs-after |
405 LC_ALL=C sed -e '/^[^ ][^ ]* \([^ ][^ ]*\) \1$/d' |
406 while read ref old new; do
407 echo "$loghhmmss $old $new $ref" >&3
408 freshen_loose_objects "$old" "$new"
409 echo "$old $new $ref"
410 done
411 LC_ALL=C join -v 1 .refs-before .refs-after |
412 while read ref old; do
413 echo "$loghhmmss $old 0000000000000000000000000000000000000000 $ref" >&3
414 freshen_loose_objects "$old"
415 echo "$old 0000000000000000000000000000000000000000 $ref"
416 done
417 LC_ALL=C join -v 2 .refs-before .refs-after |
418 while read ref new; do
419 echo "$loghhmmss 0000000000000000000000000000000000000000 $new $ref" >&3
420 freshen_loose_objects "$new"
421 echo "0000000000000000000000000000000000000000 $new $ref"
422 done
423 git for-each-ref --format='%(objectname) %(objectname) %(refname)' refs/heads
424 } >.refs-temp 3>>"$logname"
425 if [ -S "$sockpath" ]; then
426 nc_openbsd -w 15 -U "$sockpath" <.refs-temp || :
428 bang config_set lastchange "$(date '+%a, %d %b %Y %T %z')"
429 bang_eval "git for-each-ref --sort=-committerdate --format='%(committerdate:iso8601)' \
430 --count=1 refs/heads > info/lastactivity"
431 ! [ -d htmlcache ] || { >htmlcache/changed; } 2>/dev/null || :
432 # While unlikely, it is conceivable that several ref updates have occurred that
433 # did not actually create any packs. In that case we could build up a large
434 # number of log files so request gc if there are more than 50 of them now.
435 # In the case of a mirror this is a practical impossibility but we check anyway.
436 if ! [ -e .needsgc ]; then
437 logfiles=
438 { logfiles="$(($(find reflogs -maxdepth 1 -type f -print | wc -l || :)+0))" || :; } 2>/dev/null
439 if [ -n "$logfiles" ] && [ "$logfiles" -ge 50 ]; then
440 >.needsgc
443 rm -f .delaygc .allowgc
446 # If the repository does not yet have a valid HEAD symref try to set one
447 # If an empty repository was cloned and then later becomes unempty you just
448 # lose out on the fancy "symref=HEAD:" logic and get this version instead
449 check_and_set_head || :
451 rm -f .refs-before .refs-after .refs-temp FETCH_HEAD
453 if is_banged; then
454 [ -z "$mailaddrs" ] || ! was_banged_message_sent ||
456 echo "$proj update succeeded - failure recovery"
457 echo "this status message may be disabled on the project admin page"
458 } | mail -s "[$cfg_name] $proj update succeeded" "$mailaddrs" || :
459 bang_reset
462 progress "- [$proj] update (`date`)"